#include <iostream>

const int MAX_S = 2000;
const int MAX_V = 100;
const int INF = MAX_S + 1;

// najmanji broj novčića potreban da se naplati iznos S
// kada su nam na raspolaganju n vrednosti novčića datih u nizu v
int minBrojNovcica(int v[], int n, int s) {
    // iznos 0 se plaća sa 0 novčića
    if (s == 0)
        return 0;

    // ako nema novčića pozitivan iznos nije moguće platiti
    if (n == 0)
        return INF;

    // broj novčića ako se ne uzme ni jedan novčić poslednje vrste
    int br = minBrojNovcica(v, n-1, s);

    // ako je iznos veći od novčića poslednje vrste
    if (s >= v[n-1])
        // gledamo da li je bolje ako se uzme jedan novčić poslednje vrste
        br = std::min(br, minBrojNovcica(v, n, s - v[n-1]) + 1);

    // vraćamo rezultat
    return br;
}

// matrica koju koristimo za memoizaciju
int memo[MAX_V][MAX_S + 1];

int minBrojNovcica(int v[], int n, int s){
    // ako smo već računali vrednost za (n, s), vraćamo upamćeni rezultat
    if (memo[n][s] != 0)
        return memo[n][s];

    // iznos 0 se naplaćuje sa 0 novčića
    if (s == 0)
        return memo[n][s] = 0;

    // ako nema novčića pozitivan iznos nije moguće platiti
    if (n == 0)
        return memo[n][s] = INF;

    // broj novčića ako se ne uzme ni jedan novčić poslednje vrste
    int br = minBrojNovcica(v, n-1, s);

    // ako je iznos veći od novčića poslednje vrste
    if (s >= v[n-1])
        // gledamo da li je bolje ako se uzme jedan novčić poslednje vrste
        br = std::min(br, minBrojNovcica(v, n, s - v[n-1]) + 1);

    // vraćamo rezultat
    return memo[n][s] = br;
}