#include <iostream>
#include <vector>

int ranac(const std::vector<int> &tezine, const std::vector<int> &vrednosti, int n, int kapacitet)
{
    // Ako nemamo vise predmeta koje mozemo ubaciti ili ako je popunjen kapacitet ranca
    if (n == 0 || kapacitet == 0) {
        return 0;
    }

    // Ako se predmet ne ubaci u ranac jer prosto ne moze da stane
    if (tezine[n - 1] > kapacitet) {
        return ranac(tezine, vrednosti, n - 1, kapacitet);
    }

    // Ako ne ubacimo predmet u ranac
    int bez_predmeta = ranac(tezine, vrednosti, n - 1, kapacitet);
    // Ako ubacimo predmet u ranac
    int sa_predmetom = vrednosti[n - 1] + ranac(tezine, vrednosti, n - 1, kapacitet - tezine[n - 1]);

    // Gledamo koje resenje je bolje, tj sta donosi vecu vrednost
    return std::max(bez_predmeta, sa_predmetom);
}

int ranac_v2(const std::vector<int> &tezine, const std::vector<int> &vrednosti, int n, int kapacitet, std::vector<std::vector<int>> matrica)
{
    if (matrica[n - 1][kapacitet] != -1) {
        return matrica[n - 1][kapacitet];
    }

    int rezultat;

    if (n == 0 || kapacitet == 0) {
        rezultat = 0;
    }
    else if (tezine[n - 1] > kapacitet) {
        rezultat = ranac(tezine, vrednosti, n - 1, kapacitet);
    }
    else {
        int bez_predmeta = ranac(tezine, vrednosti, n - 1, kapacitet);
        int sa_predmetom = vrednosti[n - 1] + ranac(tezine, vrednosti, n - 1, kapacitet - tezine[n - 1]);

        rezultat = std::max(bez_predmeta, sa_predmetom); 
    }

    matrica[n - 1][kapacitet] = rezultat;
    return rezultat;
}

int ranac_v3(const std::vector<int> &tezine, const std::vector<int> &vrednosti, int n, int kapacitet)
{
    std::vector<std::vector<int>> matrica(n + 1);
    matrica[0].resize(kapacitet + 1, 0);

    for (int i = 1; i <= n; i++) {
        matrica[i].resize(kapacitet + 1);
        matrica[i][0] = 0;
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= kapacitet; j++) {
            if (tezine[i - 1] > j) {
                matrica[i][j] = matrica[i - 1][j];
            }
            else {
                int bez_predmeta = matrica[i - 1][j];
                int sa_predmetom = vrednosti[i - 1] + matrica[i - 1][j - tezine[i - 1]];
                matrica[i][j] = std::max(sa_predmetom, bez_predmeta);
            }
        }
    }

    return matrica[n][kapacitet];
}

int main ()
{
    int n = 4;

    std::vector<int> tezine = {1, 3, 4, 5};
    std::vector<int> vrednosti = {1, 4, 5, 7};

    int kapacitet = 7;

    std::cout << ranac(tezine, vrednosti, n, kapacitet) << "\n";

    std::vector<std::vector<int>> matrica(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= kapacitet; j++) {
            matrica[i].push_back(-1);
        }
    }

    std::cout << ranac_v2(tezine, vrednosti, n, kapacitet, matrica) << "\n";

    std::cout << ranac_v3(tezine, vrednosti, n, kapacitet) << "\n";

    return 0;
}